#
#       HBS REDUCTION SUB ROUTINE
#
#       Bias correction: hbsbiascor.cl
#
#       1999/08/04      K.Kawabata
#
procedure hbsbiascor

begin

  file inlist
  int x1, x2, y1, y2
  int x3, x4, y3, y4
  real cnt1, cnt2, cnt
  int c, i
  string tmp_fn, buf
  string fn_stack[300], fn
  int n_image

#--- initial settings

  tmp_fn = mktemp( "hbs.tmp.fn." )

listinput:
  printf( "List file >> " )
  c = scan( inlist )
  if( access( inlist ) == 0 )
  {
    printf( "Cannot find '%s'\n", inlist )
    goto listinput
  }

  printf( "Dark region 1 (x1 y1 x2 y2) >> " )
  c = scan( x1, y1, x2, y2 )
  printf( "Dark region 2 (x3 y3 x4 y4) >> " )
  c = scan( x3, y3, x4, y4 )

#--- scan list

  n_image = 0
  list = inlist
  while( fscan( list, buf ) != EOF )
  {
    n_image += 1
    fn_stack[n_image] = buf
  }

  for( i=1; i<=n_image; i+=1 )
  {
    fn = fn_stack[i]
    printf( "%s  ", fn )

#----- Bias Correction

    imstatistics( fn//"["//x1//":"//x2//","//y1//":"//y2//"]",\
                  format-, fields="midpt", binwidth=0.1, >> tmp_fn )
    list = tmp_fn
    if( fscan( list, cnt1 ) != 1 )
    {
      printf( "Imstatistics-file read error for %s\n", fn )
      bye
    }
    delete( tmp_fn, ver- )

    imstatistics( fn//"["//x3//":"//x4//","//y3//":"//y4//"]",\
                  format-, fields="midpt", binwidth=0.1, >> tmp_fn )
    list = tmp_fn
    if( fscan( list, cnt2 ) != 1 )
    {
      printf( "Imstatistics-file read error for %s\n", fn2 )
      bye
    }
    delete( tmp_fn, ver- )

    cnt = ( cnt1 + cnt2 ) / 2.0

    printf( "%7.3f %7.3f   %7.3f\n", cnt1, cnt2, cnt )

    imarith( fn, "-", cnt, fn, pixtype="real",\
             calctype="real", ver- )
  }

end
