#
#	HBS REDUCTION SUB ROUTINE
#
#	reidentify
#                                                : hbsreidentify.cl
#
#       1998/09/04      K.Kawabata    Ver.1.00
#

procedure hbsreidentify( reffile, infile, outfile, fitysec1, coordf1,\
                         ftyp1, fwid1, thres1, crad1, dn1 )

file reffile { prompt = "reference image" }
file infile { prompt = "Input image" }
file outfile { prompt = "Output image" }
string fitysec1 { prompt = "section parameter of reidentify" }
string coordf1 { prompt = "feature position list" }
string ftyp1 { prompt = "ftype parameter of reidentify" }
real fwid1 { prompt = "fwidth parameter of reidentify" }
real thres1 { prompt = "threshold parameter of reidentify" }
real crad1 { prompt = "cradius parameter of reidentify" }
string dn1 { prompt = "nsum parameter of reidentify" }

begin

  file fn, infn, reffn, outfn
  int c
  string buf, buf1
  string fitysec2, coordf2, ftyp2
  real fwid2, thres2, crad2
  string dn2
  real x

  infn = infile
  outfn = outfile
  reffn = reffile
  fitysec2 = fitysec1
  coordf2 = coordf1
  ftyp2 = ftyp1
  fwid2 = fwid1
  thres2 = thres1
  crad2 = crad1
  dn2 = dn1

  if( access( "database/id"//reffn ) == 0 )
  {
    printf( "%s is not identified\n", reffn )
    bye
  }

  if( access( "database/id"//infn ) == 1 )
    delete( "database/id"//infn )
  if( access( outfn ) == 1 )
    delete( outfn, ver- )

  buf = ""

  reidentify( reffn, infn, section=fitysec2, database="database",\
              shift=0., cradius=crad2, nsum=dn2, nlost=0,\
              refit+, override+, coordli=coordf2,\
              maxfeat=1, trace-, interactive-, answer+, threshold=thres2 )

  while( !access( "database/id"//infn ) )
  {
    print( "reidentify failed in "//infn//".  please select" )
    print( "[r] retry identify   [m] manual input" )
    c = scan( buf )
    while( buf != "r" && buf !="m" )
      c = scan( buf )
    if( buf == "r" )
    {
      printf( "mark with 'm' on the first feature (%s)\n", ftyp2 )

      identify( infn, section=fitysec2, databas="database",\
                coordli="home$etc/null.dat", nsum=dn2, match=20.,\
                maxfeat=1, fwidth=fwid2, cradius=crad2,\
                order=2, niterate=1, low_rej=3., high_rej=3.,\
                grow=0., ftype=ftyp2, mode="ql", threshold=thres2,\
                autowrite+ )
    }
    else
    {
      printf( "read y-coordinate on the first feature (%s)\n", ftyp2 )
      identify( infn, section=fitysec2, databas="database",\
                coordli="home$etc/null.dat", nsum=dn2, match=20.,\
                maxfeat=1, fwidth=fwid2, cradius=crad2,\
                order=2, niterate=1, low_rej=3., high_rej=3.,\
                grow=0., ftype=ftyp2, mode="ql", threshold=thres2,\
                autowrite+ )
      printf( "input x-coodinate >> " )
      c = scan( x )
      goto step2
    }
  }

  list = "database/id"//infn
  c = fscan( list, buf, buf, buf, buf, buf, buf )
  c = fscan( list, buf, buf, buf, buf, buf, buf )
  while( fscan( list, buf1, buf, buf, buf, buf, buf ) != 6 ){}
  x = real( buf1 )

step2 :
  printf( "%6.2f\n", x, >> outfn )

end
