#
#       HBS REDUCTION SUB ROUTINE
#
#       wfits all '*.imh' in the directory : hbswfits.cl
#
#      *.imh --> *.FIT
#       2005/04/07  Modified by M.Isogai  for iraf v2.12
#

procedure hbswfits

begin

  file fn
  file inlist, outlist
  int n_version      # IRAF version (210 or 211)
  string buf1, buf2
  int c

  inlist = "hbs.tmp.in"
  outlist = "hbs.tmp.out"

#----- IRAF version check

  buf1 = envget( "version" )
  c = stridx( "V", buf1 )
  buf2 = substr( buf1, c, ( c + 4 ) )

  n_version = 0

  if( buf2 == "V2.11" || buf2 == "V2.12" )
  {
    n_version = 211
  }
  else
  {
    if( buf2 == "V2.10" )
    {
      n_version = 210
    }
  }

  if( n_version == 0 )
  {
    printf( "IRAF version check failed.\n" )
    printf( "Please input like next line, and restart 'hbsred'\n"
    printf( "cl> set version V2.10  (V2.10 and V2.11 are valid)\n"
    bye
  }

#---

  if( access( inlist ) == 1 )
    delete( inlist, ver- )
  if( access( outlist ) == 1 )
    delete( outlist, ver- )

  sections( "*.imh", option="fullname", > inlist )
  sed( 's/\.imh//', inlist, > outlist )

  list = outlist
  while( fscan( list, fn ) != EOF )
  {

    printf( "%s  ", fn )  
    if( access( fn ) == 1 )
      delete( fn, ver- )


    if( n_version == 210 )
    { 
      wfits( fn//".imh", fn//".FIT", bscale=1.0, bzero=0.0, long_header-,
             short_header-, bitpix=-32, scale-, autoscale- )
    }
    else{
      if( n_version == 211 )
      {
      wfits( fn//".imh", fn//".FIT", bscale=1.0, bzero=0.0, long_header-,
             fextn="", short_header-, bitpix=-32, scale-, autoscale- )
      }
      else
      {
        printf( "IRAF version erorr (%d)\n", n_version )
        bye
      }
    }
    if( access( fn//".FIT" ) == 1 )
      imdelete( fn, ver- )
  }
  delete( inlist, ver- )
  delete( outlist, ver- )
  
  printf( "\n" )  
    
end
